/* eslint-disable semi */
<template>
  <div>
    <Navbar></Navbar>
    <Header></Header>
    <div
      v-if="loaded"
      class="background pt-3"
    >
      <b-container class="pb-3">
        <div class="dropdown">
          <h3 class="pl-2">Here are our top 10 favourite quotes!</h3>
          <b-dropdown
            text="Sort"
            class="m-sm-2"
          >
            <b-dropdown-item @click="onSortQuotes('rating ascending')">Rating ascending </b-dropdown-item>
            <b-dropdown-item @click="onSortQuotes('rating descending' )">Rating descending</b-dropdown-item>
            <b-dropdown-item @click="onSortQuotes('alpha ascending')">Alphabetically ascending</b-dropdown-item>
            <b-dropdown-item @click="onSortQuotes('alpha descending')">Alphabetically descending</b-dropdown-item>
          </b-dropdown>
        </div>
      </b-container>
      <Quotes
        :quotes="this.listOfQuotes"
        @sort-quotes="onSortQuotes"
      ></Quotes>
    </div>
    <Footer></Footer>
  </div>
</template>
<script lang="ts">
import Vue from 'vue'
import BootstrapVue from 'bootstrap-vue'
Vue.use(BootstrapVue)
import 'bootstrap/dist/css/bootstrap.css'
import 'bootstrap-vue/dist/bootstrap-vue.css'
import Navbar from '@/components/Navbar.vue'
import Quotes from '@/components/Quotes.vue'
import Header from '@/components/Header.vue'
import Footer from '@/components/Footer.vue'

import Restclient from '../services/Restclient'

export default {
  name: 'home',
  components: {
    Navbar,
    Header,
    Quotes,
    Footer
  },
  data() {
    return {
      restclient: new Restclient(),
      listOfQuotes: [],
      loaded: false
    }
  },
  created: async function() {
    let onePageOfQuotes = await this.restclient.getOnePageOfQuotes()
    this.listOfQuotes = onePageOfQuotes.splice(10, onePageOfQuotes.length)
    if (this.listOfQuotes != null) this.loaded = true
  },
  methods: {
    onSortQuotes(typeOfSort: String) {
      switch (typeOfSort) {
        case 'rating ascending':
          this.listOfQuotes = this.listOfQuotes.sort((a, b) =>
            a.rating > b.rating ? 1 : -1
          )
          break
        case 'rating descending':
          this.listOfQuotes = this.listOfQuotes.sort((a, b) =>
            a.rating < b.rating ? 1 : -1
          )
          break
        case 'alpha ascending':
          this.listOfQuotes = this.listOfQuotes.sort((a, b) =>
            a.author > b.author ? 1 : -1
          )
          break
        case 'alpha descending':
          this.listOfQuotes = this.listOfQuotes.sort((a, b) =>
            a.author < b.author ? 1 : -1
          )
          break
        default:
      }
    }
  }
}
</script>
<style scoped>
.background {
  background-color: #557a95;
}
.dropdown {
  display: flex;
  justify-content: space-between;
  align-items: center;
  background: white;
  border-radius: 4px;
}
.background {
  background-color: #557a95;
}
@media screen and (max-width: 991px) {
  h3 {
    font-size: 20px;
  }
}
@media screen and (max-width: 575px) {
  h3 {
    font-size: 15px;
  }
}
</style>
